//+------------------------------------------------------------------+
//|                                                         nema.mq4 |
//|                                                           mladen | 
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    Nema1Period     = 20;
extern int    Nema1Price      = PRICE_CLOSE;
extern int    Nema1Depth      =  2;
extern int    Nema2Period     = 50;
extern int    Nema2Price      = PRICE_CLOSE;
extern int    Nema2Depth      =  2;
extern bool   alertsOn        = False;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double nema1[];
double nema2[];
double trend[];
double dotUp[];
double dotDn[];
double work1[][50];
double coeff1[50];
double work2[][50];
double coeff2[50];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,nema1);
   SetIndexBuffer(1,nema2);
   SetIndexBuffer(2,dotUp); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   SetIndexBuffer(3,dotDn); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
   SetIndexBuffer(4,trend);
   
         Nema1Depth = MathMax(MathMin(Nema1Depth,49),1);
         Nema2Depth = MathMax(MathMin(Nema2Depth,49),1);
         if (Nema1Period>Nema2Period)
         {
            int temp = Nema1Period;
                       Nema1Period = Nema2Period;
                       Nema2Period = temp;
         }                       
         for(int k=0; k<=Nema1Depth; k++) coeff1[k] = factorial(Nema1Depth)/(factorial(Nema1Depth-k)*factorial(k));
         for(    k=0; k<=Nema2Depth; k++) coeff2[k] = factorial(Nema2Depth)/(factorial(Nema2Depth-k)*factorial(k));
         
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
         
   return(0); 
}
int deinit(){ return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,k,n,r,limit, counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { nema1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      double alpha1 = 2.0 / (1.0+Nema1Period);
      double alpha2 = 2.0 / (1.0+Nema2Period);
      if (ArrayRange(work1,0)!=Bars) { ArrayResize(work1,Bars); ArrayResize(work2,Bars); }
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         nema1[i] = 0;
         nema2[i] = 0;
 
         //
         //
         //
         //
         //
         //
         
         double price = iMA(NULL,0,1,0,MODE_SMA,Nema1Price,i);
         double sign = 1;
         for (k=0; k<Nema1Depth; k++, sign *= -1)
         {
            if (r<2)
                  work1[r][k] = price;
            else  work1[r][k] = work1[r-1][k]+alpha1*(price-work1[r-1][k]);
            price = work1[r][k];
            nema1[i] += price*sign*coeff1[k+1];
         }            

         //
         //
         //
         //
         //
         
         price = iMA(NULL,0,1,0,MODE_SMA,Nema2Price,i);
         sign  = 1;
         for (k=0; k<Nema2Depth; k++, sign *= -1)
         {
            if (r<2)
                  work2[r][k] = price;
            else  work2[r][k] = work2[r-1][k]+alpha2*(price-work2[r-1][k]);
            price = work2[r][k];
            nema2[i] += price*sign*coeff2[k+1];
         }            

         //
         //
         //
         //
      
         dotUp[i] = EMPTY_VALUE;
         dotDn[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (nema1[i] > nema2[i]) trend[i] =  1;
            if (nema1[i] < nema2[i]) trend[i] = -1;
            if (trend[i]!= trend[i+1])
               if (trend[i] ==1)
                     dotUp[i] = nema2[i] - iATR(NULL,0,20,i)/2;
               else  dotDn[i] = nema1[i] + iATR(NULL,0,20,i)/2;
      }       
      manageAlerts();
      return(0);
   }      

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         dotUp[i] = EMPTY_VALUE;
         dotDn[i] = EMPTY_VALUE;
         nema1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Nema1Period,Nema1Price,Nema1Depth,Nema2Period,Nema2Price,Nema2Depth,0,y);
         nema2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Nema1Period,Nema1Price,Nema1Depth,Nema2Period,Nema2Price,Nema2Depth,1,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Nema1Period,Nema1Price,Nema1Depth,Nema2Period,Nema2Price,Nema2Depth,4,y);
         if(trend[i]!=trend[i+1])
            { 
               if (trend[i] ==1)
                     dotUp[i] = nema2[i] - iATR(NULL,0,20,i)/2;
               else  dotDn[i] = nema1[i] + iATR(NULL,0,20,i)/2;
            }                     
            
         //
         //
         //
         //
         //
      
         if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if (!Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
               nema1[i+k] = nema1[i] + (nema1[i+n]-nema1[i])*k/n;
               nema2[i+k] = nema2[i] + (nema2[i+n]-nema2[i])*k/n;
            }               
   }

   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double factorial(int n)
{
   double a=1; for(int i=1; i<=n; i++) a*=i;
   return(a);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," nema crosses trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"nema crosses "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}